import { __assign } from "tslib";
import React, { useState, useRef } from 'react';
import { usePicker } from './context';
import { getHandleValue } from './utils';
import { usePaintSat, usePaintLight, usePaintBright } from './usePaintHue';
import { barWrap, psRl, barWrapInner, cResize, handle } from './style';
var tinycolor = require("tinycolor2");
var AdvancedControls = function (_a) {
    var openAdvanced = _a.openAdvanced;
    var _b = usePicker(), tinyColor = _b.tinyColor, hue = _b.hue, l = _b.l, handleChange = _b.handleChange, s = _b.s, opacity = _b.opacity, squareSize = _b.squareSize;
    var _c = tinyColor.toHsv(), v = _c.v, vs = _c.s;
    var satRef = useRef(null);
    var lightRef = useRef(null);
    var brightRef = useRef(null);
    usePaintSat(satRef, hue, l * 100, squareSize);
    usePaintLight(lightRef, hue, s * 100, squareSize);
    usePaintBright(brightRef, hue, s * 100, squareSize);
    var satDesat = function (value) {
        var _a = tinycolor({ h: hue, s: value / 100, l: l }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setLight = function (value) {
        var _a = tinycolor({ h: hue, s: s, l: value / 100 }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setBright = function (value) {
        var _a = tinycolor({ h: hue, s: vs * 100, v: value }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    return (React.createElement("div", { style: { height: openAdvanced ? 136 : 0, width: '100%', transition: 'all 120ms linear' } },
        React.createElement("div", { style: { paddingTop: 11, display: openAdvanced ? '' : 'none' } },
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, lineHeight: 1 } }, "Saturation"),
            React.createElement(AdvBar, { left: s * squareSize - 18, reffy: satRef, callback: satDesat }),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, lineHeight: 1 } }, "Lightness"),
            React.createElement(AdvBar, { left: l * squareSize - 18, reffy: lightRef, callback: setLight }),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, lineHeight: 1 } }, "Brightness"),
            React.createElement(AdvBar, { left: v * squareSize - 18, reffy: brightRef, callback: setBright }))));
};
export default AdvancedControls;
var AdvBar = function (_a) {
    var left = _a.left, callback = _a.callback, reffy = _a.reffy;
    var squareSize = usePicker().squareSize;
    var _b = useState(false), dragging = _b[0], setDragging = _b[1];
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            callback(getHandleValue(e));
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            callback(getHandleValue(e));
        }
    };
    return (React.createElement("div", { onMouseEnter: stopDragging, onMouseLeave: stopDragging, style: __assign(__assign({}, barWrap), { width: squareSize + 36, marginTop: 0 }) },
        React.createElement("div", { onMouseUp: stopDragging, style: __assign(__assign(__assign({}, psRl), barWrapInner), { width: squareSize + 30 }) },
            React.createElement("div", { className: 'c-resize ps-rl', onMouseMove: function (e) { return handleMove(e); }, style: __assign(__assign({}, cResize), psRl) },
                React.createElement("div", { style: __assign(__assign({}, handle), { left: left, top: 2 }), onMouseDown: function () { return setDragging(true); } }),
                React.createElement("canvas", { ref: reffy, width: "".concat(squareSize, "px"), height: '14px', style: { position: 'relative', borderRadius: 14 }, onClick: function (e) { return handleClick(e); } })))));
};
//# sourceMappingURL=AdvancedControls.js.map