import { __assign } from "tslib";
import React from 'react';
import PropTypes from 'prop-types';
import { usePicker } from './context';
import { psRl, df, jfe } from './style';
var ComparibleColors = function (_a) {
    var openComparibles = _a.openComparibles;
    var _b = usePicker(), tinyColor = _b.tinyColor, handleChange = _b.handleChange;
    var analogous = tinyColor.analogous();
    var monochromatic = tinyColor.monochromatic();
    var triad = tinyColor.triad();
    var tetrad = tinyColor.tetrad();
    var handleClick = function (tiny) {
        var _a = tiny.toRgb(), r = _a.r, g = _a.g, b = _a.b, a = _a.a;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(a, ")"));
    };
    return (React.createElement("div", { style: { height: openComparibles ? 216 : 0, width: '100%', transition: 'all 120ms linear' } },
        React.createElement("div", { style: __assign({ paddingTop: 11, display: openComparibles ? '' : 'none' }, psRl) },
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 13, fontWeight: 600, position: 'absolute', top: 6.5, left: 2 } }, "Color Guide"),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Analogous"),
            React.createElement("div", { style: __assign({ borderRadius: 5, overflow: 'hidden' }, df) }, analogous === null || analogous === void 0 ? void 0 : analogous.map(function (c, key) { return (React.createElement("div", { key: key, style: { width: '20%', height: 30, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Monochromatic"),
            React.createElement("div", { style: __assign(__assign({ borderRadius: 5, overflow: 'hidden' }, df), jfe) }, monochromatic === null || monochromatic === void 0 ? void 0 : monochromatic.map(function (c, key) { return (React.createElement("div", { key: key, style: { width: '20%', height: 30, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Triad"),
            React.createElement("div", { style: __assign(__assign({ borderRadius: 5, overflow: 'hidden' }, df), jfe) }, triad === null || triad === void 0 ? void 0 : triad.map(function (c, key) { return (React.createElement("div", { key: key, style: { width: 'calc(100% / 3)', height: 28, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Tetrad"),
            React.createElement("div", { style: __assign(__assign({ borderRadius: 5, overflow: 'hidden' }, df), jfe) }, tetrad === null || tetrad === void 0 ? void 0 : tetrad.map(function (c, key) { return (React.createElement("div", { key: key, style: { width: '25%', height: 28, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })))));
};
export default ComparibleColors;
ComparibleColors.propTypes = {
    openComparibles: PropTypes.bool,
};
//# sourceMappingURL=ComparibleColors.js.map