import { __assign } from "tslib";
import React, { useState } from 'react';
import { SlidersIcon, InputsIcon, PaletteIcon } from './icon';
import { usePicker } from './context';
import EyeDropper from 'react-color-eye-dropper';
import { config } from './constants';
import AdvancedControls from './AdvancedControls';
import ComparibleColors from './ComparibleColors';
import GradientControls from './GradientControls';
import { ac, df, jc, jsb, inputDropdown, psRl, jfe, controlBtn } from './style';
var defaultColor = config.defaultColor, defaultGradient = config.defaultGradient;
var Controls = function (_a) {
    var hideEyeDrop = _a.hideEyeDrop, hideAdvancedSliders = _a.hideAdvancedSliders, hideColorGuide = _a.hideColorGuide, hideInputType = _a.hideInputType;
    var _b = usePicker(), isGradient = _b.isGradient, onChange = _b.onChange, previousColors = _b.previousColors, previousGraidents = _b.previousGraidents, handleChange = _b.handleChange;
    var _c = useState(false), openAdvanced = _c[0], setOpenAdvanced = _c[1];
    var _d = useState(false), openComparibles = _d[0], setOpenComparibles = _d[1];
    var _e = useState(false), openInputType = _e[0], setOpenInputType = _e[1];
    var noTools = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
    var solidColor = (previousColors === null || previousColors === void 0 ? void 0 : previousColors[0]) || defaultColor;
    var gradientColor = (previousGraidents === null || previousGraidents === void 0 ? void 0 : previousGraidents[0]) || defaultGradient;
    var setSolid = function () {
        onChange(solidColor);
    };
    var setGradient = function () {
        onChange(gradientColor);
    };
    return (React.createElement("div", { style: { paddingTop: 12, paddingBottom: 9 } },
        React.createElement("div", { style: __assign(__assign(__assign({ width: '100%' }, df), jsb), ac) },
            React.createElement("div", { style: __assign(__assign(__assign({ height: 28, background: '#e9e9f5', borderRadius: 6, padding: 2 }, df), jc), ac) },
                React.createElement("div", { style: __assign(__assign(__assign(__assign({}, controlBtn), controlBtnStyles(!isGradient)), df), ac), onClick: setSolid }, "Solid"),
                React.createElement("div", { style: __assign(__assign(__assign(__assign({}, controlBtn), controlBtnStyles(isGradient)), df), ac), onClick: setGradient }, "Gradient")),
            React.createElement("div", { style: __assign(__assign(__assign(__assign({}, ac), jfe), { height: 28, background: '#e9e9f5', borderRadius: 6, padding: 2, display: noTools ? 'none' : '' }), df) },
                !hideEyeDrop && React.createElement(EyeDropper, { onSelect: handleChange, buttonStyle: { width: 30, height: 24, borderRadius: 4, display: 'flex', alignItems: 'center', justifyContent: 'center' } }),
                React.createElement("div", { style: __assign(__assign(__assign(__assign({ width: 30 }, controlBtnStyles(openAdvanced)), { height: 24, borderRadius: 4, display: hideAdvancedSliders ? 'none' : 'flex' }), jc), ac), onClick: function () { return setOpenAdvanced(!openAdvanced); } },
                    React.createElement(SlidersIcon, { color: openAdvanced ? '#568CF5' : '' })),
                React.createElement("div", { style: __assign(__assign(__assign(__assign({ width: 30 }, controlBtnStyles(openComparibles)), { height: 24, borderRadius: 4, display: hideColorGuide ? 'none' : 'flex' }), jc), ac), onClick: function () { return setOpenComparibles(!openComparibles); } },
                    React.createElement(PaletteIcon, { color: openComparibles ? '#568CF5' : '' })),
                React.createElement("div", { style: __assign(__assign(__assign(__assign(__assign({ width: 30 }, controlBtnStyles(openInputType)), { height: 24, borderRadius: 4, display: hideInputType ? 'none' : 'flex' }), jc), ac), psRl), onClick: function () { return setOpenInputType(!openInputType); } },
                    React.createElement(InputsIcon, { color: openInputType ? '#568CF5' : '' }),
                    React.createElement(InputTypeDropdown, { openInputType: openInputType, setOpenInputType: setOpenInputType })))),
        !hideAdvancedSliders && React.createElement(AdvancedControls, { openAdvanced: openAdvanced }),
        !hideColorGuide && React.createElement(ComparibleColors, { openComparibles: openComparibles }),
        isGradient && React.createElement(GradientControls, null)));
};
export default Controls;
var InputTypeDropdown = function (_a) {
    var openInputType = _a.openInputType, setOpenInputType = _a.setOpenInputType;
    var _b = usePicker(), inputType = _b.inputType, setInputType = _b.setInputType;
    var vTrans = openInputType ? 'visibility 0ms linear' : 'visibility 100ms linear 150ms';
    var zTrans = openInputType ? 'z-index 0ms linear' : 'z-index 100ms linear 150ms';
    var oTrans = openInputType ? 'opacity 120ms linear' : 'opacity 150ms linear 50ms';
    var handleInputType = function (e, val) {
        if (openInputType) {
            e.stopPropagation();
            setInputType(val);
            setOpenInputType(false);
        }
    };
    return (React.createElement("div", { style: __assign({ visibility: openInputType ? 'visible' : 'hidden', zIndex: openInputType ? '' : -100, opacity: openInputType ? 1 : 0, transition: "".concat(oTrans, ", ").concat(vTrans, ", ").concat(zTrans) }, inputDropdown) },
        React.createElement("div", { style: __assign(__assign(__assign(__assign(__assign({}, controlBtnStyles(inputType === 'rgb')), df), ac), psRl), controlBtn), onClick: function (e) { return handleInputType(e, 'rgb'); } }, "RGB"),
        React.createElement("div", { style: __assign(__assign(__assign(__assign({}, controlBtnStyles(inputType === 'hsl')), df), ac), controlBtn), onClick: function (e) { return handleInputType(e, 'hsl'); } }, "HSL"),
        React.createElement("div", { style: __assign(__assign(__assign(__assign({}, controlBtnStyles(inputType === 'hsv')), df), ac), controlBtn), onClick: function (e) { return handleInputType(e, 'hsv'); } }, "HSV"),
        React.createElement("div", { style: __assign(__assign(__assign(__assign({}, controlBtnStyles(inputType === 'cmyk')), df), ac), controlBtn), onClick: function (e) { return handleInputType(e, 'cmyk'); } }, "CMYK")));
};
export var controlBtnStyles = function (selected) {
    return {
        background: selected ? 'white' : '',
        color: selected ? '#568CF5' : '',
        boxShadow: selected ? '0px 0px 8px rgba(0,0,0,.125)' : ''
    };
};
//# sourceMappingURL=Controls.js.map