import { __assign } from "tslib";
import React, { useState } from "react";
import { getHandleValue } from './utils';
import { usePicker } from "./context";
import { barWrap, psRl, barWrapInner, df, jc, ac, gradientHandleWrap, gradientHandle } from './style';
var GradientBar = function () {
    var _a = usePicker(), currentColor = _a.currentColor, addPoint = _a.addPoint, colors = _a.colors, value = _a.value, handleGradient = _a.handleGradient, squareSize = _a.squareSize;
    var _b = useState(false), dragging = _b[0], setDragging = _b[1];
    function force90degLinear(string) {
        return color.replace(/(radial|linear)-gradient\([^,]+,/, 'linear-gradient(90deg,');
    }
    var stopDragging = function () {
        setDragging(false);
    };
    var handleDown = function (e) {
        if (!dragging) {
            addPoint(e);
        }
    };
    var handleMove = function (e) {
        if (dragging) {
            handleGradient(currentColor, getHandleValue(e));
        }
    };
    return (React.createElement("div", { onMouseEnter: stopDragging, onMouseLeave: stopDragging, style: __assign(__assign({}, barWrap), { width: squareSize + 36 }) },
        React.createElement("div", { onMouseUp: stopDragging, style: __assign(__assign({}, psRl), barWrapInner) },
            React.createElement("div", { onMouseDown: function (e) { return handleDown(e); }, onMouseMove: function (e) { return handleMove(e); }, style: { paddingTop: 6, paddingBottom: 6 } },
                React.createElement("div", { style: { width: squareSize, height: 14, backgroundImage: force90degLinear(value), borderRadius: 10 } })), colors === null || colors === void 0 ? void 0 :
            colors.map(function (c, i) { return (React.createElement(Handle, { left: c.left, key: "".concat(i, "-").concat(c), i: i, setDragging: setDragging })); }))));
};
export default GradientBar;
export var Handle = function (_a) {
    var left = _a.left, i = _a.i, setDragging = _a.setDragging;
    var _b = usePicker(), setSelectedColor = _b.setSelectedColor, selectedColor = _b.selectedColor, squareSize = _b.squareSize;
    var isSelected = selectedColor === i;
    var leftMultiplyer = (squareSize - 18) / 100;
    var handleDown = function (e) {
        e.stopPropagation();
        setSelectedColor(i);
        setDragging(true);
    };
    return (React.createElement("div", { style: __assign({ left: left * leftMultiplyer + 13 }, gradientHandleWrap), onMouseDown: function (e) { return handleDown(e); } },
        React.createElement("div", { style: __assign(__assign(__assign(__assign(__assign({}, handleStyle(isSelected)), gradientHandle), df), jc), ac) }, isSelected && React.createElement("div", { style: { width: 5, height: 5, borderRadius: '50%', background: 'white' } }))));
};
var handleStyle = function (isSelected) {
    return {
        boxShadow: isSelected ? '0px 0px 5px 1px rgba(86, 140, 245,.95)' : '',
        border: isSelected ? '2px solid white' : '2px solid rgba(255,255,255,.75)',
    };
};
//# sourceMappingURL=GradientBar.js.map