import React from "react";
import Hue from "./Hue";
import Inputs from './Inputs';
import Square from "./Square";
import Opacity from './Opacity';
import Presets from './Presets';
import Controls from './Controls';
import PropTypes from 'prop-types';
import GradientBar from './GradientBar';
import { usePicker } from './context';
var Picker = function (_a) {
    var hideControls = _a.hideControls, hideInputs = _a.hideInputs, hidePresets = _a.hidePresets, presets = _a.presets, hideEyeDrop = _a.hideEyeDrop, hideAdvancedSliders = _a.hideAdvancedSliders, hideColorGuide = _a.hideColorGuide, hideInputType = _a.hideInputType;
    var isGradient = usePicker().isGradient;
    return (React.createElement("div", { style: { userSelect: 'none' } },
        React.createElement(Square, null),
        !hideControls && React.createElement(Controls, { hideEyeDrop: hideEyeDrop, hideAdvancedSliders: hideAdvancedSliders, hideColorGuide: hideColorGuide, hideInputType: hideInputType }),
        isGradient && React.createElement(GradientBar, null),
        React.createElement(Hue, null),
        React.createElement(Opacity, null),
        !hideInputs && React.createElement(Inputs, null),
        !hidePresets && React.createElement(Presets, { presets: presets })));
};
export default Picker;
Picker.propTypes = {
    hideControls: PropTypes.bool,
    hideInputs: PropTypes.bool,
    hidePresets: PropTypes.bool,
    presets: PropTypes.array,
    hideEyeDrop: PropTypes.bool,
    hideAdvancedSliders: PropTypes.bool,
    hideColorGuide: PropTypes.bool,
    hideInputType: PropTypes.bool,
};
//# sourceMappingURL=Picker.js.map