import { __assign } from "tslib";
import React, { useRef, useState } from "react";
import throttle from "lodash.throttle";
import usePaintSquare from "./usePaintSquare";
import { usePicker } from './context';
import { psRl, cCross, handle, canvasWrapper } from './style';
var Square = function () {
    var _a = usePicker(), handleColor = _a.handleColor, x = _a.x, y = _a.y, internalHue = _a.internalHue, squareSize = _a.squareSize, squareHeight = _a.squareHeight;
    var _b = useState(false), dragging = _b[0], setDragging = _b[1];
    var canvas = useRef(null);
    usePaintSquare(canvas, internalHue, squareSize, squareHeight);
    var handleChange = function (e) {
        var _a;
        var ctx = (_a = canvas === null || canvas === void 0 ? void 0 : canvas.current) === null || _a === void 0 ? void 0 : _a.getContext("2d");
        var onMouseMove = throttle(function () { return handleColor(e, ctx); }, 250);
        onMouseMove();
    };
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            handleChange(e);
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            handleChange(e);
        }
    };
    return (React.createElement("div", { style: psRl },
        React.createElement("div", { style: { position: 'absolute', left: -7, top: -7, width: squareSize + 14, height: squareHeight + 14 }, onMouseEnter: stopDragging }),
        React.createElement("div", { style: __assign(__assign({}, psRl), cCross), onMouseMove: function (e) { return handleMove(e); }, onMouseUp: stopDragging },
            React.createElement("div", { style: __assign({ left: x, top: y }, handle), onMouseDown: function () { return setDragging(true); } }),
            React.createElement("div", { style: __assign(__assign({}, canvasWrapper), { height: squareHeight }), onClick: function (e) { return handleClick(e); } },
                React.createElement("canvas", { ref: canvas, width: "".concat(squareSize, "px"), height: "".concat(squareHeight, "px"), id: 'paintSquare' })))));
};
export default Square;
//# sourceMappingURL=Square.js.map