"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var context_1 = require("./context");
var utils_1 = require("./utils");
var usePaintHue_1 = require("./usePaintHue");
var style_1 = require("./style");
var tinycolor = require("tinycolor2");
var AdvancedControls = function (_a) {
    var openAdvanced = _a.openAdvanced;
    var _b = (0, context_1.usePicker)(), tinyColor = _b.tinyColor, hue = _b.hue, l = _b.l, handleChange = _b.handleChange, s = _b.s, opacity = _b.opacity, squareSize = _b.squareSize;
    var _c = tinyColor.toHsv(), v = _c.v, vs = _c.s;
    var satRef = (0, react_1.useRef)(null);
    var lightRef = (0, react_1.useRef)(null);
    var brightRef = (0, react_1.useRef)(null);
    (0, usePaintHue_1.usePaintSat)(satRef, hue, l * 100, squareSize);
    (0, usePaintHue_1.usePaintLight)(lightRef, hue, s * 100, squareSize);
    (0, usePaintHue_1.usePaintBright)(brightRef, hue, s * 100, squareSize);
    var satDesat = function (value) {
        var _a = tinycolor({ h: hue, s: value / 100, l: l }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setLight = function (value) {
        var _a = tinycolor({ h: hue, s: s, l: value / 100 }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setBright = function (value) {
        var _a = tinycolor({ h: hue, s: vs * 100, v: value }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    return (react_1.default.createElement("div", { style: { height: openAdvanced ? 136 : 0, width: '100%', transition: 'all 120ms linear' } },
        react_1.default.createElement("div", { style: { paddingTop: 11, display: openAdvanced ? '' : 'none' } },
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, lineHeight: 1 } }, "Saturation"),
            react_1.default.createElement(AdvBar, { left: s * squareSize - 18, reffy: satRef, callback: satDesat }),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, lineHeight: 1 } }, "Lightness"),
            react_1.default.createElement(AdvBar, { left: l * squareSize - 18, reffy: lightRef, callback: setLight }),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, lineHeight: 1 } }, "Brightness"),
            react_1.default.createElement(AdvBar, { left: v * squareSize - 18, reffy: brightRef, callback: setBright }))));
};
exports.default = AdvancedControls;
var AdvBar = function (_a) {
    var left = _a.left, callback = _a.callback, reffy = _a.reffy;
    var squareSize = (0, context_1.usePicker)().squareSize;
    var _b = (0, react_1.useState)(false), dragging = _b[0], setDragging = _b[1];
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            callback((0, utils_1.getHandleValue)(e));
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            callback((0, utils_1.getHandleValue)(e));
        }
    };
    return (react_1.default.createElement("div", { onMouseEnter: stopDragging, onMouseLeave: stopDragging, style: tslib_1.__assign(tslib_1.__assign({}, style_1.barWrap), { width: squareSize + 36, marginTop: 0 }) },
        react_1.default.createElement("div", { onMouseUp: stopDragging, style: tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, style_1.psRl), style_1.barWrapInner), { width: squareSize + 30 }) },
            react_1.default.createElement("div", { className: 'c-resize ps-rl', onMouseMove: function (e) { return handleMove(e); }, style: tslib_1.__assign(tslib_1.__assign({}, style_1.cResize), style_1.psRl) },
                react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({}, style_1.handle), { left: left, top: 2 }), onMouseDown: function () { return setDragging(true); } }),
                react_1.default.createElement("canvas", { ref: reffy, width: "".concat(squareSize, "px"), height: '14px', style: { position: 'relative', borderRadius: 14 }, onClick: function (e) { return handleClick(e); } })))));
};
//# sourceMappingURL=AdvancedControls.js.map