"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var prop_types_1 = tslib_1.__importDefault(require("prop-types"));
var context_1 = require("./context");
var style_1 = require("./style");
var ComparibleColors = function (_a) {
    var openComparibles = _a.openComparibles;
    var _b = (0, context_1.usePicker)(), tinyColor = _b.tinyColor, handleChange = _b.handleChange;
    var analogous = tinyColor.analogous();
    var monochromatic = tinyColor.monochromatic();
    var triad = tinyColor.triad();
    var tetrad = tinyColor.tetrad();
    var handleClick = function (tiny) {
        var _a = tiny.toRgb(), r = _a.r, g = _a.g, b = _a.b, a = _a.a;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(a, ")"));
    };
    return (react_1.default.createElement("div", { style: { height: openComparibles ? 216 : 0, width: '100%', transition: 'all 120ms linear' } },
        react_1.default.createElement("div", { style: tslib_1.__assign({ paddingTop: 11, display: openComparibles ? '' : 'none' }, style_1.psRl) },
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 13, fontWeight: 600, position: 'absolute', top: 6.5, left: 2 } }, "Color Guide"),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Analogous"),
            react_1.default.createElement("div", { style: tslib_1.__assign({ borderRadius: 5, overflow: 'hidden' }, style_1.df) }, analogous === null || analogous === void 0 ? void 0 : analogous.map(function (c, key) { return (react_1.default.createElement("div", { key: key, style: { width: '20%', height: 30, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Monochromatic"),
            react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ borderRadius: 5, overflow: 'hidden' }, style_1.df), style_1.jfe) }, monochromatic === null || monochromatic === void 0 ? void 0 : monochromatic.map(function (c, key) { return (react_1.default.createElement("div", { key: key, style: { width: '20%', height: 30, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Triad"),
            react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ borderRadius: 5, overflow: 'hidden' }, style_1.df), style_1.jfe) }, triad === null || triad === void 0 ? void 0 : triad.map(function (c, key) { return (react_1.default.createElement("div", { key: key, style: { width: 'calc(100% / 3)', height: 28, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3 } }, "Tetrad"),
            react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ borderRadius: 5, overflow: 'hidden' }, style_1.df), style_1.jfe) }, tetrad === null || tetrad === void 0 ? void 0 : tetrad.map(function (c, key) { return (react_1.default.createElement("div", { key: key, style: { width: '25%', height: 28, background: c.toHexString() }, onClick: function () { return handleClick(c); } })); })))));
};
exports.default = ComparibleColors;
ComparibleColors.propTypes = {
    openComparibles: prop_types_1.default.bool,
};
//# sourceMappingURL=ComparibleColors.js.map