"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Handle = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var utils_1 = require("./utils");
var context_1 = require("./context");
var style_1 = require("./style");
var GradientBar = function () {
    var _a = (0, context_1.usePicker)(), currentColor = _a.currentColor, addPoint = _a.addPoint, colors = _a.colors, value = _a.value, handleGradient = _a.handleGradient, squareSize = _a.squareSize;
    var _b = (0, react_1.useState)(false), dragging = _b[0], setDragging = _b[1];
    function force90degLinear(string) {
        return color.replace(/(radial|linear)-gradient\([^,]+,/, 'linear-gradient(90deg,');
    }
    var stopDragging = function () {
        setDragging(false);
    };
    var handleDown = function (e) {
        if (!dragging) {
            addPoint(e);
        }
    };
    var handleMove = function (e) {
        if (dragging) {
            handleGradient(currentColor, (0, utils_1.getHandleValue)(e));
        }
    };
    return (react_1.default.createElement("div", { onMouseEnter: stopDragging, onMouseLeave: stopDragging, style: tslib_1.__assign(tslib_1.__assign({}, style_1.barWrap), { width: squareSize + 36 }) },
        react_1.default.createElement("div", { onMouseUp: stopDragging, style: tslib_1.__assign(tslib_1.__assign({}, style_1.psRl), style_1.barWrapInner) },
            react_1.default.createElement("div", { onMouseDown: function (e) { return handleDown(e); }, onMouseMove: function (e) { return handleMove(e); }, style: { paddingTop: 6, paddingBottom: 6 } },
                react_1.default.createElement("div", { style: { width: squareSize, height: 14, backgroundImage: force90degLinear(value), borderRadius: 10 } })), colors === null || colors === void 0 ? void 0 :
            colors.map(function (c, i) { return (react_1.default.createElement(exports.Handle, { left: c.left, key: "".concat(i, "-").concat(c), i: i, setDragging: setDragging })); }))));
};
exports.default = GradientBar;
var Handle = function (_a) {
    var left = _a.left, i = _a.i, setDragging = _a.setDragging;
    var _b = (0, context_1.usePicker)(), setSelectedColor = _b.setSelectedColor, selectedColor = _b.selectedColor, squareSize = _b.squareSize;
    var isSelected = selectedColor === i;
    var leftMultiplyer = (squareSize - 18) / 100;
    var handleDown = function (e) {
        e.stopPropagation();
        setSelectedColor(i);
        setDragging(true);
    };
    return (react_1.default.createElement("div", { style: tslib_1.__assign({ left: left * leftMultiplyer + 13 }, style_1.gradientHandleWrap), onMouseDown: function (e) { return handleDown(e); } },
        react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign(tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, handleStyle(isSelected)), style_1.gradientHandle), style_1.df), style_1.jc), style_1.ac) }, isSelected && react_1.default.createElement("div", { style: { width: 5, height: 5, borderRadius: '50%', background: 'white' } }))));
};
exports.Handle = Handle;
var handleStyle = function (isSelected) {
    return {
        boxShadow: isSelected ? '0px 0px 5px 1px rgba(86, 140, 245,.95)' : '',
        border: isSelected ? '2px solid white' : '2px solid rgba(255,255,255,.75)',
    };
};
//# sourceMappingURL=GradientBar.js.map