"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var lodash_throttle_1 = tslib_1.__importDefault(require("lodash.throttle"));
var usePaintSquare_1 = tslib_1.__importDefault(require("./usePaintSquare"));
var context_1 = require("./context");
var style_1 = require("./style");
var Square = function () {
    var _a = (0, context_1.usePicker)(), handleColor = _a.handleColor, x = _a.x, y = _a.y, internalHue = _a.internalHue, squareSize = _a.squareSize, squareHeight = _a.squareHeight;
    var _b = (0, react_1.useState)(false), dragging = _b[0], setDragging = _b[1];
    var canvas = (0, react_1.useRef)(null);
    (0, usePaintSquare_1.default)(canvas, internalHue, squareSize, squareHeight);
    var handleChange = function (e) {
        var _a;
        var ctx = (_a = canvas === null || canvas === void 0 ? void 0 : canvas.current) === null || _a === void 0 ? void 0 : _a.getContext("2d");
        var onMouseMove = (0, lodash_throttle_1.default)(function () { return handleColor(e, ctx); }, 250);
        onMouseMove();
    };
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            handleChange(e);
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            handleChange(e);
        }
    };
    return (react_1.default.createElement("div", { style: style_1.psRl },
        react_1.default.createElement("div", { style: { position: 'absolute', left: -7, top: -7, width: squareSize + 14, height: squareHeight + 14 }, onMouseEnter: stopDragging }),
        react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({}, style_1.psRl), style_1.cCross), onMouseMove: function (e) { return handleMove(e); }, onMouseUp: stopDragging },
            react_1.default.createElement("div", { style: tslib_1.__assign({ left: x, top: y }, style_1.handle), onMouseDown: function () { return setDragging(true); } }),
            react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({}, style_1.canvasWrapper), { height: squareHeight }), onClick: function (e) { return handleClick(e); } },
                react_1.default.createElement("canvas", { ref: canvas, width: "".concat(squareSize, "px"), height: "".concat(squareHeight, "px"), id: 'paintSquare' })))));
};
exports.default = Square;
//# sourceMappingURL=Square.js.map