"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatInputValues = exports.getColors = exports.high = exports.low = void 0;
var constants_1 = require("./constants");
var gradientParser_1 = require("./gradientParser");
var defaultColor = constants_1.config.defaultColor, defaultGradient = constants_1.config.defaultGradient;
var low = function (color) {
    return color.value.toLowerCase();
};
exports.low = low;
var high = function (color) {
    return color.value.toUpperCase();
};
exports.high = high;
var getColors = function (value) {
    var isGradient = value === null || value === void 0 ? void 0 : value.includes('gradient');
    if (isGradient) {
        var isConic = value === null || value === void 0 ? void 0 : value.includes('conic');
        var safeValue = !isConic && validate(value) ? value : defaultGradient;
        if (isConic) {
            console.log('Sorry we cant handle conic gradients yet');
        }
        var obj = (0, gradientParser_1.gradientParser)(safeValue);
        return obj === null || obj === void 0 ? void 0 : obj.colorStops;
    }
    else {
        var safeValue = validate(value) ? value : defaultColor;
        return [{ value: safeValue }];
    }
};
exports.getColors = getColors;
var validate = function (c) {
    var img = document.createElement('img');
    img.style = 'background: rgb(0, 0, 0)';
    img.style = 'background: ' + c;
    if (img.style.background !== 'rgb(0, 0, 0)' && img.style.background !== '')
        return true;
    img.style = 'background: rgb(255, 255, 255)';
    img.style = 'background: ' + c;
    return (img.style.background !== 'rgb(255, 255, 255)' && img.style.background !== '');
};
var formatInputValues = function (value, min, max) {
    return isNaN(value) ? min : value < min ? min : value > max ? max : value;
};
exports.formatInputValues = formatInputValues;
//# sourceMappingURL=formatters.js.map